<!---
================================================================
機能名：プロジェクト情報用コンポーネント
概要　 ：プロジェクト情報で使用するコンポーネント
作成者：千葉　博胤
作成日：2009/10/01
================================================================
--->
<cfcomponent name="pjinfo">

<!---===========================================================
機能　　：プロジェクト登録
関数名　：insProject
引数　　：
戻り値	：
============================================================--->
<cffunction name="insProject" access="public" output="false" returntype="void">
	<cfargument name="project_nm" required="yes" type="string"><!--- プロジェクト名 --->
	<cfargument name="customer_cd" required="yes" type="string"><!--- 顧客コード --->
	<cfargument name="exp_start_dt" required="yes" type="string"><!--- 開始予定日 --->
	<cfargument name="exp_end_dt" required="yes" type="string"><!--- 終了予定日 --->
	<cfargument name="dlv_dt" required="yes" type="string"><!--- 納品日 --->
	<cfargument name="acpt_dt" required="yes" type="string"><!--- 検収日 --->
	<cfargument name="ov_view" required="yes" type="string"><!--- 概要 --->
	<cfargument name="sales_cd" required="yes" type="string"><!--- 営業担当 --->
	<cfargument name="status_cd" required="yes" type="string"><!--- 状況コード --->

	<cfquery  name="getPjcd" datasource="#Application.dsname#">
		select PROJECT_CD from T_PROJECT
	</cfquery>

	<cfset newProject_cd = NumberFormat(getPjcd.RecordCount + 1,'0000')>

	<cfquery  name="qInsProject" datasource="#Application.dsname#">
		INSERT INTO T_PROJECT
		(
			PROJECT_CD,
			PROJECT_NM,
			CUSTOMER_CD,
			EXPECTED_START,
			EXPECTED_END,
			DELIVERY_DT,
			ACCEPTANCE_DT,
			OVERVIEW,
			SALES_CD,
			STATUS_CD
		)
		VALUES
		(
			'#newProject_cd#',
			'#Arguments.project_nm#',
			'#Arguments.customer_cd#',
			'#Arguments.exp_start_dt#',
			'#Arguments.exp_end_dt#',
			<cfif Arguments.dlv_dt EQ "">NULL,<cfelse>'#Arguments.dlv_dt#',</cfif>
			<cfif Arguments.acpt_dt EQ "">NULL,<cfelse>'#Arguments.acpt_dt#',</cfif>
			'#Arguments.ov_view#',
			'#Arguments.sales_cd#',
			'#Arguments.status_cd#'
		)
	</cfquery>

</cffunction>

<!---===========================================================
機能　　：プロジェクト更新
関数名　：updProject
引数　　：
戻り値	：
============================================================--->
<cffunction name="updProject" access="public" output="false" returntype="void">
	<cfargument name="project_cd" required="yes" type="string"><!--- プロジェクトコード --->
	<cfargument name="project_nm" required="yes" type="string"><!--- プロジェクト名 --->
	<cfargument name="customer_cd" required="yes" type="string"><!--- 顧客コード --->
	<cfargument name="exp_start_dt" required="yes" type="string"><!--- 開始予定日 --->
	<cfargument name="exp_end_dt" required="yes" type="string"><!--- 終了予定日 --->
	<cfargument name="act_start_dt" required="yes" type="string"><!--- 開始予定日 --->
	<cfargument name="act_end_dt" required="yes" type="string"><!--- 終了予定日 --->
	<cfargument name="dlv_dt" required="yes" type="string"><!--- 納品日 --->
	<cfargument name="acpt_dt" required="yes" type="string"><!--- 検収日 --->
	<cfargument name="ov_view" required="yes" type="string"><!--- 概要 --->
	<cfargument name="sales_cd" required="yes" type="string"><!--- 営業担当 --->
	<cfargument name="status_cd" required="yes" type="string"><!--- 状況コード --->

	<cfquery  name="qUpdProject" datasource="#Application.dsname#">
		UPDATE T_PROJECT
		SET
			PROJECT_NM = '#Arguments.project_nm#',
			CUSTOMER_CD = '#Arguments.customer_cd#',
			EXPECTED_START = '#Arguments.exp_start_dt#',
			EXPECTED_END = '#Arguments.exp_end_dt#',
			ACTUAL_START = <cfif Arguments.act_start_dt EQ "">NULL,<cfelse>'#Arguments.act_start_dt#',</cfif>
			ACTUAL_END = <cfif Arguments.act_end_dt EQ "">NULL,<cfelse>'#Arguments.act_end_dt#',</cfif>
			DELIVERY_DT = <cfif Arguments.dlv_dt EQ "">NULL,<cfelse>'#Arguments.dlv_dt#',</cfif>
			ACCEPTANCE_DT = <cfif Arguments.acpt_dt EQ "">NULL,<cfelse>'#Arguments.acpt_dt#',</cfif>
			OVERVIEW = '#Arguments.ov_view#',
			SALES_CD = '#Arguments.sales_cd#',
			STATUS_CD = '#Arguments.status_cd#'
		WHERE
			PROJECT_CD = '#Arguments.project_cd#'
	</cfquery>

</cffunction>


<!---===========================================================
機能　　：プロジェクト情報取得
関数名　：getProject
引数　　：
戻り値	：
============================================================--->
<cffunction name="getProject" access="public" output="false" returntype="query">
	<cfargument name="customer_nm" required="yes" type="string" defaukt=""><!--- 顧客名 --->
	<cfargument name="project_nm" required="yes" type="string" defaukt=""><!--- プロジェクト名 --->

	<cfquery  name="qGgetProject" datasource="#Application.dsname#">
		SELECT
			PJ.PROJECT_CD,
			PJ.PROJECT_NM,
			CS.CUSTOMER_NM,
			PJ.EXPECTED_START,
			PJ.EXPECTED_END,
			PJ.ACTUAL_START,
			PJ.ACTUAL_END,
			PJ.DELIVERY_DT,
			PJ.ACCEPTANCE_DT,
			PJ.OVERVIEW,
			PJ.SALES_CD,
			PJ.STATUS_CD,
			ST.STATUS_NM
		FROM T_PROJECT PJ
		INNER JOIN M_CUSTOMER CS ON
			PJ.CUSTOMER_CD = CS.CUSTOMER_CD
		INNER JOIN M_STATUS ST ON
			PJ.STATUS_CD=ST.STATUS_CD
		WHERE
			0=0
			<cfif Arguments.customer_nm NEQ ''>
			AND CS.CUSTOMER_NM LIKE '%#Arguments.customer_nm#%'
			</cfif>
			<cfif Arguments.project_nm NEQ ''>
			AND PJ.PROJECT_NM LIKE '%#Arguments.project_nm#%'
			</cfif>
	</cfquery>

    <cfreturn qGgetProject>
</cffunction>

<!---===========================================================
機能　　：プロジェクト情報取得
関数名　：getProjectInCode
引数　　：
戻り値	：
============================================================--->
<cffunction name="getProjectInCode" access="public" output="false" returntype="query">
	<cfargument name="project_cd" required="yes" type="string" defaukt=""><!--- プロジェクトコード --->

	<cfquery  name="qGgetProject" datasource="#Application.dsname#">
		SELECT
			PJ.PROJECT_CD,
			PJ.PROJECT_NM,
			PJ.CUSTOMER_CD,
			CS.CUSTOMER_NM,
			PJ.EXPECTED_START,
			PJ.EXPECTED_END,
			PJ.ACTUAL_START,
			PJ.ACTUAL_END,
			PJ.DELIVERY_DT,
			PJ.ACCEPTANCE_DT,
			PJ.OVERVIEW,
			PJ.SALES_CD,
			PJ.STATUS_CD,
			ST.STATUS_NM
		FROM T_PROJECT PJ
		INNER JOIN M_CUSTOMER CS ON
			PJ.CUSTOMER_CD = CS.CUSTOMER_CD
		INNER JOIN M_STATUS ST ON
			PJ.STATUS_CD=ST.STATUS_CD
		WHERE
			PJ.PROJECT_CD = '#Arguments.project_cd#'
	</cfquery>

    <cfreturn qGgetProject>
</cffunction>
</cfcomponent>