<!---
================================================================
機能名：工程管理用コンポーネント
概要　：工程管理で使用するコンポーネント
作成者：千葉　博胤
作成日：2009/10/01
================================================================
--->
<cfcomponent name="processmng">

<!---===========================================================
機能　　：工程一覧取得
関数名　：getProcessList
引数　　：
戻り値	：
============================================================--->
<cffunction name="getProcessList" access="public" output="false" returntype="query">
	<cfargument name="project_cd" required="yes" type="string" defaukt=""><!--- プロジェクトコード --->

	<cfquery  name="qGetProcessList" datasource="#Application.dsname#">
		SELECT
			PC.PROJECT_CD,
			PC.PROCESS_CD,
			PC.PROCESS_SEQ,
			EP.EMPLOYEE_NM,
			PC.FUNCTION_NM,
			MP.PROCESS,
			PC.EXPECTED_START,
			PC.EXPECTED_END,
			PC.ACTUAL_START,
			PC.ACTUAL_END,
			ST.STATUS_NM,
			PC.NOTES
		FROM T_PROCESS PC
		INNER JOIN M_EMPLOYEE EP ON
			PC.EMPLOYEE_CD = EP.EMPLOYEE_CD
		INNER JOIN M_STATUS ST ON
			PC.STATUS_CD=ST.STATUS_CD
		INNER JOIN M_PROCESS MP ON
			PC.PROCESS_CD = MP.PROCESS_CD
		WHERE
			PC.PROJECT_CD = '#Arguments.project_cd#'
		ORDER BY PC.PROCESS_CD,PC.PROCESS_SEQ
	</cfquery>

    <cfreturn qGetProcessList>
</cffunction>

<!---===========================================================
機能　　：工程情報取得
関数名　：getProcess
引数　　：
戻り値	：
============================================================--->
<cffunction name="getProcess" access="public" output="false" returntype="query">
	<cfargument name="project_cd" required="yes" type="string" defaukt=""><!--- プロジェクトコード --->
	<cfargument name="process_cd" required="yes" type="string" defaukt=""><!--- 工程コード --->
	<cfargument name="process_seq" required="yes" type="string" defaukt=""><!--- 工程SEQ --->

	<cfquery  name="qGetProcess" datasource="#Application.dsname#">
		SELECT
			PROJECT_CD,
			PROCESS_CD,
			PROCESS_SEQ,
			EMPLOYEE_CD,
			FUNCTION_NM,
			EXPECTED_START,
			EXPECTED_END,
			ACTUAL_START,
			ACTUAL_END,
			STATUS_CD,
			NOTES
		FROM T_PROCESS
		WHERE
			PROJECT_CD = '#Arguments.project_cd#' and
			PROCESS_CD = '#Arguments.process_cd#' and
			PROCESS_SEQ = '#Arguments.process_seq#'
	</cfquery>

    <cfreturn qGetProcess>
</cffunction>

<!---===========================================================
機能　　：プロジェクト情報取得
関数名　：getProjectInCode
引数　　：
戻り値	：
============================================================--->
<cffunction name="getProjectInCode" access="public" output="false" returntype="query">
	<cfargument name="project_cd" required="yes" type="string" defaukt=""><!--- プロジェクトコード --->

	<cfquery  name="qGgetProject" datasource="#Application.dsname#">
		SELECT
			PJ.PROJECT_CD,
			PJ.PROJECT_NM,
			CS.CUSTOMER_NM,
			PJ.EXPECTED_START,
			PJ.EXPECTED_END,
			PJ.ACTUAL_START,
			PJ.ACTUAL_END,
			PJ.DELIVERY_DT,
			PJ.ACCEPTANCE_DT,
			PJ.OVERVIEW,
			PJ.SALES_CD,
			PJ.STATUS_CD,
			ST.STATUS_NM
		FROM T_PROJECT PJ
		INNER JOIN M_CUSTOMER CS ON
			PJ.CUSTOMER_CD = CS.CUSTOMER_CD
		INNER JOIN M_STATUS ST ON
			PJ.STATUS_CD=ST.STATUS_CD
		WHERE
			PJ.PROJECT_CD = '#Arguments.project_cd#'
	</cfquery>

    <cfreturn qGgetProject>
</cffunction>

<!---===========================================================
機能　　：工程登録
関数名　：insProcess
引数　　：
戻り値	：
============================================================--->
<cffunction name="insProcess" access="public" output="false" returntype="void">
	<cfargument name="project_cd" required="yes" type="string"><!--- プロジェクトコード --->
	<cfargument name="process_cd" required="yes" type="string"><!--- 工程コード --->
	<cfargument name="function_nm" required="yes" type="string"><!--- 機能名 --->
	<cfargument name="exp_start_dt" required="yes" type="string"><!--- 開始予定日 --->
	<cfargument name="exp_end_dt" required="yes" type="string"><!--- 終了予定日 --->
	<cfargument name="act_start_dt" required="yes" type="string"><!--- 開始実績日 --->
	<cfargument name="act_end_dt" required="yes" type="string"><!--- 終了実績日 --->
	<cfargument name="emp_cd" required="yes" type="string"><!--- 担当コード --->
	<cfargument name="status_cd" required="yes" type="string"><!--- 状況コード --->
	<cfargument name="notes" required="yes" type="string"><!--- 備考 --->

	<cfquery  name="getPseq" datasource="#Application.dsname#">
		SELECT IFNULL(MAX(CAST(process_seq AS signed)),0) AS SEQ FROM T_PROCESS
		WHERE PROJECT_CD = '#Arguments.project_cd#' AND PROCESS_CD = '#Arguments.process_cd#'
	</cfquery>

	<cfset Variables.newProcess_seq = getPseq.SEQ + 1>

	<cfquery  name="qInsProcess" datasource="#Application.dsname#">
		INSERT INTO T_PROCESS
		(
			PROJECT_CD,
			PROCESS_CD,
			PROCESS_SEQ,
			FUNCTION_NM,
			EMPLOYEE_CD,
			EXPECTED_START,
			EXPECTED_END,
			ACTUAL_START,
			ACTUAL_END,
			STATUS_CD,
			NOTES
		)
		VALUES
		(
			'#Arguments.project_cd#',
			'#Arguments.process_cd#',
			'#Variables.newProcess_seq#',
			'#Arguments.function_nm#',
			'#Arguments.emp_cd#',
			'#Arguments.exp_start_dt#',
			'#Arguments.exp_end_dt#',
			<cfif Arguments.act_start_dt NEQ "">
			'#Arguments.act_start_dt#',
			<cfelse>
			NULL,
			</cfif>
			<cfif Arguments.act_start_dt NEQ "">
			'#Arguments.act_end_dt#',
			<cfelse>
			NULL,
			</cfif>
			'#Arguments.status_cd#',
			'#Arguments.notes#'
		)
	</cfquery>

</cffunction>

<!---===========================================================
機能　　：工程更新
関数名　：updProcess
引数　　：
戻り値	：
============================================================--->
<cffunction name="updProcess" access="public" output="false" returntype="void">
	<cfargument name="project_cd" required="yes" type="string"><!--- プロジェクトコード --->
	<cfargument name="process_cd" required="yes" type="string"><!--- 工程コード --->
	<cfargument name="process_seq" required="yes" type="string"><!--- 工程SEQ --->
	<cfargument name="function_nm" required="yes" type="string"><!--- 機能名 --->
	<cfargument name="exp_start_dt" required="yes" type="string"><!--- 開始予定日 --->
	<cfargument name="exp_end_dt" required="yes" type="string"><!--- 終了予定日 --->
	<cfargument name="act_start_dt" required="yes" type="string"><!--- 開始実績日 --->
	<cfargument name="act_end_dt" required="yes" type="string"><!--- 終了実績日 --->
	<cfargument name="emp_cd" required="yes" type="string"><!--- 担当コード --->
	<cfargument name="status_cd" required="yes" type="string"><!--- 状況コード --->
	<cfargument name="notes" required="yes" type="string"><!--- 備考 --->
	
	<!--- 工程情報取得 --->
	<cfinvoke  method="getProcess" returnvariable="retProcess">
		<cfinvokeargument name="project_cd" value="#url.project_cd#"><!--- プロジェクトコード --->
		<cfinvokeargument name="process_cd" value="#url.process_cd#"><!--- 工程コード --->
		<cfinvokeargument name="process_seq" value="#url.process_seq#"><!--- 工程SEQ --->
	</cfinvoke>
	
	<!--- 工程コードが変更になった場合は、SEQを振りなおす --->
	<cfif retProcess.process_cd eq Arguments.process_cd>
		<cfset Variables.newProcess_seq = Arguments.process_seq>
	<cfelse>
		<cfquery  name="getPseq" datasource="#Application.dsname#">
			SELECT IFNULL(MAX(CAST(process_seq AS signed)),0) AS SEQ FROM T_PROCESS
			WHERE PROJECT_CD = '#Arguments.project_cd#' AND PROCESS_CD = '#Arguments.process_cd#'
		</cfquery>
		<cfset Variables.newProcess_seq = getPseq.SEQ + 1>
		<cfdump var="#getPseq#">
	</cfif>

	<cfquery  name="qInsProcess" datasource="#Application.dsname#">
		UPDATE T_PROCESS
		SET
			PROCESS_CD = '#Arguments.process_cd#',
			PROCESS_SEQ = '#Variables.newProcess_seq#',
			FUNCTION_NM = '#Arguments.function_nm#',
			EMPLOYEE_CD = '#Arguments.emp_cd#',
			EXPECTED_START = '#Arguments.exp_start_dt#',
			EXPECTED_END = '#Arguments.exp_end_dt#',
			<cfif Arguments.act_start_dt NEQ "">
			ACTUAL_START = '#Arguments.act_start_dt#',
			<cfelse>
			ACTUAL_START = NULL,
			</cfif>
			<cfif Arguments.act_start_dt NEQ "">
			ACTUAL_END = '#Arguments.act_end_dt#',
			<cfelse>
			ACTUAL_END = NULL,
			</cfif>
			STATUS_CD = '#Arguments.status_cd#',
			NOTES = '#Arguments.notes#'
		WHERE
			PROJECT_CD = '#Arguments.project_cd#' and
			PROCESS_CD = '#url.process_cd#' and
			PROCESS_SEQ = '#Arguments.process_seq#'
	</cfquery>

</cffunction>

<!---===========================================================
機能　　：工程削除
関数名　：delProcess
引数　　：
戻り値	：
============================================================--->
<cffunction name="delProcess" access="public" output="false" returntype="void">
	<cfargument name="project_cd" required="yes" type="string"><!--- プロジェクトコード --->
	<cfargument name="process_cd" required="yes" type="string"><!--- 工程コード --->
	<cfargument name="process_seq" required="yes" type="string"><!--- 工程SEQ --->

	<cfquery  name="qInsProcess" datasource="#Application.dsname#">
		DELETE FROM T_PROCESS
		WHERE
			PROJECT_CD = '#Arguments.project_cd#' and
			PROCESS_CD = '#Arguments.process_cd#' and
			PROCESS_SEQ = '#Arguments.process_seq#'
	</cfquery>

</cffunction>



</cfcomponent>