﻿<cfprocessingdirective pageencoding="utf-8" />
<cfsetting enablecfoutputonly="true" />

<cfobject component="pjmng.cmp.processmng" name="objProcessmng">
<cfobject component="pjmng.cmp.masterData" name="objMasterData">

<!--- プロジェクト情報取得 --->
<cfinvoke component="#objProcessmng#" method="getProjectInCode" returnvariable="retProjectInCode">
	<cfinvokeargument name="project_cd" value="#url.project_cd#"><!--- プロジェクトコード --->
</cfinvoke>

<!--- 工程取得 --->
<cfinvoke component="#objMasterData#" method="getProcessMst" returnvariable="retProcessMst" />

<!--- 状況取得 --->
<cfinvoke component="#objMasterData#" method="getStatusMst" returnvariable="retStatus" />

<!--- 技術者データ取得（営業以外） --->
<cfinvoke component="#objMasterData#" method="getEngineer" returnvariable="retEngineer">
	<cfinvokeargument name="department_cd" value="03">
</cfinvoke>

<!--- 変数の初期化 --->
<cfparam name="Variables.process_cd" default="">
<cfparam name="Variables.function_nm" default="">
<cfparam name="Variables.exp_start_dt" default="">
<cfparam name="Variables.exp_end_dt" default="">
<cfparam name="Variables.act_start_dt" default="">
<cfparam name="Variables.act_end_dt"default="">
<cfparam name="Variables.emp_cd"default="">
<cfparam name="Variables.status_cd"default="">
<cfparam name="Variables.note" default="">

<!--- 工程登録と工程編集それぞれの処理 --->
<cfif StructKeyExists(url,'process_cd') and StructKeyExists(url,'process_seq')>

	<!--- 工程情報取得 --->
	<cfinvoke component="#objProcessmng#" method="getProcess" returnvariable="retProcess">
		<cfinvokeargument name="project_cd" value="#url.project_cd#"><!--- プロジェクトコード --->
		<cfinvokeargument name="process_cd" value="#url.process_cd#"><!--- 工程コード --->
		<cfinvokeargument name="process_seq" value="#url.process_seq#"><!--- 工程SEQ --->
	</cfinvoke>
	<!--- DBから取得した工程情報をローカル変数にセットする --->
	<cfif retProcess.RecordCount NEQ 0>
		<cfset Variables.process_cd = "#retProcess.PROCESS_CD#">
		<cfset Variables.function_nm = "#retProcess.FUNCTION_NM#">
		<cfset Variables.exp_start_dt = "#retProcess.EXPECTED_START#">
		<cfset Variables.exp_end_dt = "#retProcess.EXPECTED_END#">
		<cfset Variables.act_start_dt = "#retProcess.ACTUAL_START#">
		<cfset Variables.act_end_dt = "#retProcess.ACTUAL_END#">
		<cfset Variables.emp_cd = "#retProcess.EMPLOYEE_CD#">
		<cfset Variables.status_cd = "#retProcess.STATUS_CD#">
		<cfset Variables.note = "#retProcess.NOTES#">
	</cfif>
	
	<!--- ボタンの表示名 --->
	<cfset Variables.buttonNm = "更　新">
	
	<!--- URLパラメータ --->
	<cfset Variables.urlParam = "?project_cd=#url.project_cd#&process_cd=#url.process_cd#&process_seq=#url.process_seq#">

<cfelse>

	<!--- ボタンの表示名 --->
	<cfset Variables.buttonNm = "登　録">
	
	<!--- URLパラメータ --->
	<cfset Variables.urlParam = "?project_cd=#url.project_cd#">
	
</cfif>


<cfsetting enablecfoutputonly="false" />
<html>
<head>
	<title>PJ登録</title>
	<link rel="stylesheet" href="./common/default.css" type="text/css">
	<cfinclude template="./common/meta.cfm">
</head>
<body>
<cfinclude template="./common/header.cfm">
<br />
<br />
<br />

<div align="center">
<cfform name="frm1" action="processmng03.cfm#Variables.urlParam#"
		format="flash" skin="haloGreen" width="800">

<cfoutput query="retProjectInCode">
<cfformgroup type="HBox" width="700">
	<cfformgroup type="HBox" width="50">
		<cfformitem type="text">顧客名：</cfformitem>
	</cfformgroup>
	<cfformgroup type="HBox" width="150">
		<cfformitem type="text">#CUSTOMER_NM#</cfformitem>
	</cfformgroup>
	<cfformgroup type="HBox" width="80">
		<cfformitem type="text">プロジェクト名：</cfformitem>
	</cfformgroup>
	<cfformgroup type="HBox" width="150">
		<cfformitem type="text">#PROJECT_NM#</cfformitem>
	</cfformgroup>
</cfformgroup>
</cfoutput>


<cfformgroup type="Panel" label="工程登録"
        style="marginTop:20; marginBottom:20;
        headerColors:##8fbc8f, ##ffffff; cornerRadius:12;">


	<cfformgroup type="HBox" width="700" height="50">
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">工程</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfselect name="process_cd" query="retProcessMst"value="process_cd" display="process" queryposition="below"
						width="100" required="true" message="工程を選択して下さい。" selected="#Variables.process_cd#">
				<option name="00"></option>
			</cfselect>
		</cfformgroup>
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">機能</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="text" name="function_nm" size="20" maxlength="40" value="#Variables.function_nm#"
					 required="true" message="機能を入力して下さい。">
		</cfformgroup>
	</cfformgroup>

	<cfformgroup type="HBox" width="600" height="50">
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text" >開始日付（予）</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="datefield" name="exp_start_dt" width="90" mask="YYYY/MM/DD" value="#Variables.exp_start_dt#"
					 required="true" message="開始日付（予）を入力して下さい。">
		</cfformgroup>
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">終了日付（予）</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="datefield" name="exp_end_dt" width="90" mask="YYYY/MM/DD" value="#Variables.exp_end_dt#"
					 required="true" message="終了日付（予）を入力して下さい。">
		</cfformgroup>
	</cfformgroup>

	<cfformgroup type="HBox" width="600" height="50">
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text" >開始日付（実）</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="datefield" name="act_start_dt" width="90" mask="YYYY/MM/DD" value="#Variables.act_start_dt#">
		</cfformgroup>
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">終了日付（実）</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="datefield" name="act_end_dt" width="90" mask="YYYY/MM/DD" value="#Variables.act_end_dt#">
		</cfformgroup>
	</cfformgroup>


	<cfformgroup type="HBox" width="600" height="50">
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">担当</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfselect name="emp_cd" query="retEngineer" value="employee_cd" display="employee_nm" queryposition="below"
						width="100" required="true" message="営業担当を選択して下さい。" selected="#Variables.emp_cd#">
				<option name="00"></option>
			</cfselect>
		</cfformgroup>
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">状況</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfselect name="status_cd" query="retStatus"value="status_cd" display="status_nm" queryposition="below"
						width="100" required="true" message="状況を選択して下さい。" selected="#Variables.status_cd#">
				<option name="00"></option>
			</cfselect>
		</cfformgroup>
	</cfformgroup>

	<cfformgroup type="HBox" width="700" height="50">
		<cfformgroup type="HBox" width="100">
			<cfformitem type="text">備考</cfformitem>
		</cfformgroup>
		<cfformgroup type="HBox">
			<cfinput type="text" name="notes" size="20" maxlength="40" value="#Variables.note#">
		</cfformgroup>
	</cfformgroup>


	<cfformgroup type="HBox" width="700" height="80">
		<cfformgroup type="page">
			<cfformitem type="spacer" width="500" />
		</cfformgroup>
		<cfformgroup type="page">
			<cfinput type="submit" name="entry" value="#Variables.buttonNm#" height="50" width="80" style="fontWeight:bold; fontSize:14;">
		</cfformgroup>
	</cfformgroup>

</cfformgroup>

</cfform>
</div>
</body>
</html>
